﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace CardReader {
  /// <summary>
  /// Object representing basic data from an eID
  /// </summary>
  public class BasicCardData {

    private string name, firstName, street, zipcode, city, countryCode, nationalNumber;
    private DateTime birthday;
    private Image photo;

    #region - Properties -

    /// <summary>
    /// Gets or sets the birthday.
    /// </summary>
    /// <value>
    /// The birthday.
    /// </value>
    public DateTime Birthday {
      get { return birthday; }
      set { birthday = value; }
    }

    /// <summary>
    /// Gets or sets the photo.
    /// </summary>
    /// <value>
    /// The photo.
    /// </value>
    public Image Photo {
      get { return photo; }
      set { photo = value; }
    }

    /// <summary>
    /// Gets or sets the national number.
    /// </summary>
    /// <value>
    /// The national number.
    /// </value>
    public string NationalNumber {
      get { return nationalNumber; }
      set { nationalNumber = value; }
    }

    /// <summary>
    /// Gets or sets the country code.
    /// </summary>
    /// <value>
    /// The country code.
    /// </value>
    public string CountryCode {
      get { return countryCode; }
      set { countryCode = value; }
    }

    /// <summary>
    /// Gets the country id.
    /// </summary>
    public int CountryId {
      get {
        if ( CountryCode == "BE" ) {
          return 1;
        } else {
          return 2;
        }
      }
    }

    /// <summary>
    /// Gets or sets the zipcode.
    /// </summary>
    /// <value>
    /// The zipcode.
    /// </value>
    public string Zipcode {
      get { return zipcode; }
      set { zipcode = value; }
    }

    /// <summary>
    /// Gets or sets the city.
    /// </summary>
    /// <value>
    /// The city.
    /// </value>
    public string City {
      get { return city; }
      set { city = value; }
    }

    /// <summary>
    /// Gets or sets the street.
    /// </summary>
    /// <value>
    /// The street.
    /// </value>
    public string Street {
      get { return street; }
      set { street = value; }
    }

    /// <summary>
    /// Gets or sets the first name.
    /// </summary>
    /// <value>
    /// The first name.
    /// </value>
    public string FirstName {
      get { return firstName; }
      set { firstName = value; }
    }

    /// <summary>
    /// Gets or sets the name.
    /// </summary>
    /// <value>
    /// The name.
    /// </value>
    public string Name {
      get { return name; }
      set { name = value; }
    }

    #endregion


  }
}
