﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DataAccess;
using System.Data;
using DCMSExceptions;

namespace BusinessLogic {
  /// <summary>
  /// Business Layer Logic for application settings
  /// </summary>
  public class AppBll {

    private AppDal dal = new AppDal( );

    /// <summary>
    /// Gets the app data.
    /// </summary>
    public void GetAppData( ) {
      try {
        dal.GetAppData( );
      } catch ( DataException ex ) {
        throw new BusinessException( "Fout bij ophalen van applicatie settings.", ex );
      }
    }

    /// <summary>
    /// Sets the app data.
    /// </summary>
    public void SetAppData( ) {
      try {
        dal.SetAppData( );
      } catch ( DataException ex ) {
        throw new BusinessException( "Fout bij bewaren van applicatie settings.", ex );
      }
    }

  }
}
