﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BusinessObjects;

namespace Interfaces {
  /// <summary>
  /// Interface for Children logic
  /// </summary>
  public interface IChildrenLogic {

    /// <summary>
    /// Gets the children.
    /// </summary>
    /// <param name="allChildren">if set to <c>true</c> [all children].</param>
    /// <returns></returns>
    Children GetChildren( bool allChildren );

    /// <summary>
    /// Gets the child.
    /// </summary>
    /// <param name="childId">The child id.</param>
    /// <returns></returns>
    Child GetChild( int childId );

    /// <summary>
    /// Saves the children.
    /// </summary>
    /// <param name="children">The children.</param>
    void SaveChildren( Children children );

    /// <summary>
    /// Saves the child.
    /// </summary>
    /// <param name="child">The child.</param>
    void SaveChild( Child child );

    /// <summary>
    /// Deletes the specified child.
    /// </summary>
    /// <param name="child">The child.</param>
    void Delete( Child child );

  }
}
