﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BusinessObjects;

namespace Interfaces {
  /// <summary>
  /// Interface for diary logic
  /// </summary>
  public interface IDiaryLogic {

    /// <summary>
    /// Gets the diary on date.
    /// </summary>
    /// <param name="date">The date.</param>
    /// <returns></returns>
    System.ComponentModel.BindingList<ChildDiary> GetDiaryOnDate( DateTime date );

    /// <summary>
    /// Saves the specified diary.
    /// </summary>
    /// <param name="diary">The diary.</param>
    void Save( ChildDiary diary );

    /// <summary>
    /// Deletes the specified diary.
    /// </summary>
    /// <param name="diary">The diary.</param>
    void Delete( ChildDiary diary );

  }
}
