﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BusinessObjects;

namespace Interfaces {
  /// <summary>
  /// Interface for trustperson logic
  /// </summary>
  public interface ITrustPersonLogic {

    /// <summary>
    /// Gets the trust persons for child.
    /// </summary>
    /// <param name="childId">The child id.</param>
    /// <returns></returns>
    TrustPersons GetTrustPersonsForChild( int childId );

    /// <summary>
    /// Deletes the trust person.
    /// </summary>
    /// <param name="trustPerson">The trust person.</param>
    void DeleteTrustPerson( TrustPerson trustPerson );

    /// <summary>
    /// Saves the trust person.
    /// </summary>
    /// <param name="trustPerson">The trust person.</param>
    void SaveTrustPerson( TrustPerson trustPerson );

  }
}
