﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BusinessObjects;

namespace Interfaces {
  /// <summary>
  /// Interface for user logic
  /// </summary>
  public interface IUserLogic {

    /// <summary>
    /// Gets the user.
    /// </summary>
    /// <param name="loginName">Name of the login.</param>
    /// <returns></returns>
    User GetUser( string loginName );

    /// <summary>
    /// Gets the auto logon user.
    /// </summary>
    /// <returns></returns>
    User GetAutoLogonUser( );

    /// <summary>
    /// Saves the user.
    /// </summary>
    /// <param name="user">The user.</param>
    void SaveUser( User user );

  }
}
